#define _GNU_SOURCE  // before ANY includes

#include <stdio.h>
#include <sys/types.h>

#include <pthread.h>
#include <sched.h>


void *sub(void *tid);

int main()
{
    int rc;
    pthread_t thrdid;

    rc = pthread_create(&thrdid,NULL,sub,(void *)1);

    sub((void *)0);

    pthread_join(thrdid,NULL);
}

void *sub(void *arg)
{
    long tid = (long)arg;
    int cpu;
    cpu_set_t mask;

    cpu = sched_getcpu();
    printf("%ld: cpu %d  \n",tid,cpu);

    /****/
    printf("%ld: sizeset %d\n",tid,sizeof(cpu_set_t));
    CPU_ZERO(&mask);
    CPU_SET(tid+3,&mask);
    printf("%ld: numseta %d  isset %d\n",tid,CPU_COUNT(&mask),CPU_ISSET(tid+3,&mask));
    sched_setaffinity(0, sizeof(cpu_set_t), &mask);

    CPU_ZERO(&mask);
    sched_getaffinity(0, sizeof(cpu_set_t), &mask);
    printf("%ld: numsetb %d  isset %d\n",tid,CPU_COUNT(&mask),CPU_ISSET(tid+3,&mask));
    /****/

    return 0;
}
